import torch
import dgl
import dgl.function as fn
import torch.nn as nn
from dgl import DGLGraph
import torch.nn.functional as F
import networkx as nx
from args import args
import random
import time
import numpy as np
def convert(filename,x):
    with open(filename,'r') as f:
         l=f.readlines()
    f.close
    n=ord(l[0][0])-63 #number of vertexs
    m=int(n*3/2) 
    p=int(n*(n-1)/2)
    last=p%6
    uptri_edges=[]
    for i in range(1,n,1):
       for j in range(0,i):
          uptri_edges.append([j,i])
    edges_index=[]
    line=l[x].strip()
    bitstring=''
    for j in range(1,len(line)):
       bitstring+=f'{ord(line[j])-63:6b}'
       #print(f'{ord(line[j])-63:6b}')
    for i in range(len(bitstring)):
        if bitstring[i]=='1':
           edges_index.append(i)
    return n,np.array(uptri_edges)[edges_index] 
def init_mf(n,bond,dim3):
    torch.manual_seed(args.seed1)
    marg_i=F.softmax(torch.rand(n, bond, dim3), dim=1)
    return marg_i
#B= A @ A.t() is a symmetric matrix
class NMFnet(nn.Module):
      def __init__(self,weight,n_classes):
        super(NMFnet,self).__init__()
        self.weight = nn.Parameter(weight)#weight is A
        
        
        self.classify = nn.Linear(self.weight.shape[2], n_classes)
      def forward(self, g, feature,k): # feature can be 3-order tensor, convolution channel 
        g.ndata['h0'] = feature
        W=torch.einsum('abc,dbc->adc',self.weight,self.weight)
        for i in range(k):     
            g.update_all(fn.copy_src(src='h'+str(i), out='m'),
                             fn.sum(msg='m', out='h'+str(i)))
            
            g.ndata['h'+str(i+1)]=F.softmax(torch.einsum('abc,bdc->adc',g.ndata['h'+str(i)],W),dim=1)
            
        # use free energy  as readout funciton
        edges=g.all_edges()
        g.edata['y']=torch.einsum('abc,bdc->adc',g.nodes[edges[0]].data['h'+str(k)],W)
        g.edata['y2']=torch.einsum('abc,abc->ac',g.edata['y'],g.nodes[edges[1]].data['h'+str(k)])
        U=-dgl.sum_edges(g,'y2')/2.0
        g.ndata['h'+str(k+1)]=torch.einsum('abc,abc->ac',g.ndata['h'+str(k)],torch.log(g.ndata['h'+str(k)]+1e-7))
        S=-dgl.sum_nodes(g,'h'+str(k+1))
        with torch.no_grad():
          S_=-dgl.mean_nodes(g,'h'+str(k+1))
          batch_n=S/S_
        
        #batch_n=g.batch_num_nodes()
        return  self.classify((U-S)/batch_n)
if __name__ =='__main__'  :
    torch.set_default_dtype(torch.float32)
    n=20
    beta=1
    #graph = nx.random_regular_graph(3, n, seed=1)
    n,edges=convert('Generated_graphs.20.03.g6',args.which)
    
    if args.permutation:
       randomindex=[i for i in range(n)]
       random.shuffle(randomindex)
       randomindex=np.array(randomindex)
       edges[:,0]=randomindex[edges[:,0]]
       edges[:,1]=randomindex[edges[:,1]]
    G=nx.Graph()
    G.add_nodes_from(np.arange(n))
    G.add_edges_from(edges)
    g=dgl.DGLGraph(G)
    n2,edges2=convert('Generated_graphs.20.03.g6',args.which+1)
    G1=nx.Graph()
    G1.add_nodes_from(np.arange(n2))
    G1.add_edges_from(edges2)
    torch.manual_seed(args.seed1)
    tensor2=torch.randn(args.bond,args.bond,4,dtype=torch.float32,device='cpu')
    #tensor2=torch.triu(tensor2)+torch.triu(tensor2,diagonal=1).t()
    mf=NMFnet(torch.exp(beta*tensor2))
    feature=init_mf(n,tensor2.shape[0],4)
    #fe_bp=mf.BP()
    #print("free_energy={:.15g}".format(fe_bp.item()))
    fe_nmf=mf(g,feature,10)
    #print("free_energy={:.15g}".format(fe_nmf.item()))      
    print(fe_nmf)
      
        
               
        
              
                
